<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on September 1, 2010 at 8:12:02 pm</time-stamp>
<!-- Changes from: PV-Datachannel(Green.258.7.19,bbuxton)  to: PV-Datachannel(Green.258.7.21,bbuxton) -->


<methods>
<class-id>Smee.SmeeAbstractObject</class-id> <category>prototype builtins-String</category>

<body package="Smee-Objects" selector="stringReplaceRegExp:with:">stringReplaceRegExp: regex with: replaceValue 
	
	| thisString match matches stream lastStop lastStart |
	thisString := self smeeToString.
	regex global 
		ifTrue: 
			[regex lastIndex: 0.
			matches := OrderedCollection new.
			[match := regex exec: thisString.
			match smeeIsNull] 
				whileFalse: 
					[matches add: match.
					match isEmpty 
						ifTrue: [regex lastIndex: regex lastIndex + 1]]]
		ifFalse: [matches := Array with: (regex exec: thisString)].
	stream := (thisString species new: thisString size) writeStream.
	lastStop := 0.
	matches do: 
		[:eachMatch | 
		stream nextPutAll: 
			(thisString 
				copyFrom: lastStop + 1
				to: (eachMatch smeeAt: #index)).
		replaceValue isSmeeFunction 
			ifTrue: 
				[self 
					stringReplaceMatch: eachMatch
					withFunction: replaceValue
					putOn: stream.
				lastStop := (eachMatch smeeAt: #index) + eachMatch first size]
			ifFalse: 
				[self 
					stringReplace: thisString
					from: (lastStart := (eachMatch smeeAt: #index) + 1)
					to: (lastStop := lastStart + eachMatch first size - 1)
					withString: replaceValue smeeToString
					putOn: stream]].
	stream nextPutAll: 
		(thisString 
			copyFrom: lastStop + 1
			to: thisString size).
	^stream contents</body>
</methods>



<methods>
<class-id>PROVISO.PvSftpResult</class-id> <category>testing</category>

<body package="PV-FTP Client" selector="message">message
	" RA# 503409. There was one case where the Sftp framework was expecting a SftpResult object to understand #message.
I am adding this in the superclass so that any similiar situations can be dealt with the same way "

	^ self asString</body>
</methods>


<methods>
<class-id>PROVISO.PvAbstractFtpClient</class-id> <category>helpers</category>

<body package="PV-FTP Client" selector="ftpFilesList">ftpFilesList
	^Array streamContents: 
			[:out | 
			self parseDirectoryContents: #()
				do: [:each | (each at: #isDir) ifFalse: [out nextPut: (each at: #name)]]]</body>

<body package="PV-FTP Client" selector="ftpDirectoryList">ftpDirectoryList
	^Array streamContents: 
			[:out | 
			self parseDirectoryContents: #()
				do: [:each | (each at: #isDir) ifTrue: [out nextPut: (each at: #name)]]]</body>
</methods>


<methods>
<class-id>PROVISO.PvFtpURL</class-id> <category>private</category>

<body package="PV-FTP Client" selector="linkToNewFilename:">linkToNewFilename: aURI

	^self copyTo: aURI</body>
</methods>


<methods>
<class-id>PROVISO.PvFtpClientConnection</class-id> <category>private</category>

<body package="PV-FTP Client" selector="receive">receive

	[| response |
	response := self commandStream through: Character cr.
	(response size &gt; 0 and: [response first = Character lf])
		ifTrue: [response := response copyFrom: 2 to: response size].
	self logReceive: response.
	^response]
		on: Error
		do: [:signal | ^'9999 - Error on ftp receive']</body>

<body package="PV-FTP Client" selector="rawResultFrom:">rawResultFrom: aString

	^PvFtpResult newFromString: aString</body>

<body package="PV-FTP Client" selector="waitForResultFrom:">waitForResultFrom: anFtpResult 
	
	| newResult lastGoodResult |
	newResult := anFtpResult.
	lastGoodResult := newResult.
	[newResult isError not and: [newResult continue]] 
		whileTrue: 
			[lastGoodResult := newResult.
			newResult := self executeWithTimeoutProtection: [self rawReceiveResult]].
	lastGoodResult isError 
		ifTrue: 
			[lastGoodResult sessionLogString: self logStream contents.
			self disconnect].
	^lastGoodResult</body>
</methods>

<methods>
<class-id>PROVISO.PvFtpClientConnection</class-id> <category>initializing</category>

<body package="PV-FTP Client" selector="resultFrom:">resultFrom: aString 
	
	| result |
	result := self rawResultFrom: aString.
	result isError 
		ifTrue: 
			[result sessionLogString: self logStream contents.
			self disconnect].
	^result</body>

<body package="PV-FTP Client" selector="rawReceiveResult">rawReceiveResult
	
	^self rawResultFrom: self receive</body>
</methods>



<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>testing</category>

<body package="PVAdaptor-Schema" selector="hasAnyInputs">hasAnyInputs
	
	self inputsToProcessByPeriodDo: [:eachSet | ^true].
	^false</body>

<body package="PVAdaptor-Schema" selector="hasAnyInputsReadyForScheduling">hasAnyInputsReadyForScheduling
	
	self inputsToProcessByPeriodDo: [:eachSet | (self shouldBeProcessed: eachSet) ifTrue: [^true]].
	^false</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Schema" selector="initializeWith:">initializeWith: anInputSchema 
	
	| filePeriod |
	schema := anInputSchema.
	filePeriod := schema filePeriod ifNil: [1].
	periodPolicy := PeriodPolicy length: filePeriod.
	self resetScheduledDescriptors</body>

<body package="PVAdaptor-Schema" selector="resetScheduledDescriptors">resetScheduledDescriptors
	
	schema inputDescriptors do: 
		[:each | 
		each alreadyProcessed 
			ifFalse: [each scheduledTimestamp: nil]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>private-accessing</category>

<body package="PVAdaptor-Schema" selector="fileInterface">fileInterface

	^self adaptor fileInterface</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>acquiring</category>

<body package="PVAdaptor-Schema" selector="acquire:withFailureLimit:">acquire: inputsToAcquire withFailureLimit: failureLimit 
	
	| failureCount |
	failureCount := 0.
	[self acquire: inputsToAcquire] 
		on: AcquisitionError
		do: 
			[:ex | 
			(failureCount := failureCount + 1) &gt; failureLimit 
				ifTrue: 
					[self system 
						logWarning: #ACQUISITION_ERROR_LIMIT
						messageId: #DC10007
						text: 
							'Too many failed acquisition attempts, giving up on remainder of input acquisitions'.
					^#()]
				ifFalse: [ex retry]].
	^inputsToAcquire</body>

<body package="PVAdaptor-Schema" selector="deleteObsoleteFiles">deleteObsoleteFiles
	
	^self fileInterface ifNotNil: 
		[:interface | interface doStateChange: [interface deleteObsoleteFiles]]</body>

<body package="PVAdaptor-Schema" selector="acquireForAdaptor:">acquireForAdaptor: anAdaptor 
	" Acquire new files in their period timestamp order. If the attempt was successful, increment N for all already acquired files whose period 
	didn't appear in the set of newly acquired files. The intended behavior is to enable 'grace period logic' if a given schema sends multiple files
	per period. We usually don't know when we see all the files in a given period and they may not appear all at once. The logic makes sure we 
	tried a few times to acquire new files and didn't see any more files in a given period. There might be no more files at all (a normal scenario
	when UBA is up to date with data, or there might already be some newer data available. In any of these situation, if an acquisition attempt
	does not bring back more files in a given period, all files in that period get their N value incremented "
	
	| acquiredPeriods existingInputs |
	self environment do: 
		[" These are newly acquired files, also grouped by their period "
		existingInputs := self inputsToProcess.
		acquiredPeriods := 
			(self acquireNew collect: [:each | self startOfPeriod: each]) asSet.
		self deleteObsoleteFiles.
		(self groupByPeriod: existingInputs) keysAndValuesDo: 
			[:eachPeriod :eachCollection | 
			(acquiredPeriods includes: eachPeriod) 
				ifFalse: [eachCollection do: [:each | each incrementNoNewInputCount]]]]</body>

<body package="PVAdaptor-Schema" selector="acquire:">acquire: inputsToAcquire 
	&lt;comment: 'The UBA failed to acquire the indicated file.'
	probableCause: 'An communications error or a misconfiguration of the file, ftp or sftp server.'
	suggestedAction: 'Check the connectivty between the UBA and the file, ftp or sftp server.  Connect to the file, ftp or sftp server by hand from the same host and user id as the UBA and make sure the directory and file indicated in the URI exists.'
	reviewed: '2010.01.20-00.00.00'&gt;

	PvFtpURL reuseClientDuring: 
		[inputsToAcquire do: 
			[:inputDescriptor | 
			[inputDescriptor acquire] 
				on: Error
				do: 
					[:ex1 | 
					"Attempt to remove any lingering, partially acquired file from the do directory"
					[inputDescriptor uriInDoDirectory delete] 
						on: Error
						do: [:ex2 | ].
					self system 
						logWarning: #ACQUISITION_FAILED
						messageId: #DC10033
						template: ##('Failed to acquire &lt;1s:schema name&gt; input: &lt;2s:file name&gt; reason: &lt;3s:error description&gt;' asLogTemplate)
						arguments: [Array with: schema name with: inputDescriptor localName with: ex1 description].
					AcquisitionError raiseRequestWith: ex1]]]</body>

<body package="PVAdaptor-Schema" selector="acquireNew">acquireNew
	
	| newInputs time |
	schema shouldAcquireURI 
		ifFalse: [^#()].
	newInputs := #().
	time := 
		Time millisecondsToRun: 
			[[[schema preAcquire.
			newInputs := 
				self 
					acquire: self newInputsToAcquire
					withFailureLimit: 3] 
				on: ODBCLicenseException
				do: [:ex | self adaptor handleODBCLicenseError: ex]] 
					on: Error
					do: [:ex | self adaptor handleInputError: ex]].
	self system 
		logDebugThree: #PERF_ACQUIRE_ALL
		messageId: #DC10020
		template: 'Acquired &lt;1p&gt; files in &lt;2p&gt; seconds'
		arguments: 
			(Array 
				with: newInputs size
				with: time / 1000.0).
	^newInputs</body>

<body package="PVAdaptor-Schema" selector="newInputsToAcquire">newInputsToAcquire
	
	| allInputs start |
	allInputs := schema inputsToAcquire reject: [:each | each alreadyAcquired].
	start := self earliestPeriodIn: allInputs.
	^allInputs select: [:each | start = (self startOfPeriod: each)]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>public</category>

<body package="PVAdaptor-Schema" selector="processInputsForAdaptor:">processInputsForAdaptor: anAdaptor 
	
	anAdaptor rootOperator executeWithWriteControl: 
		[self acquireForAdaptor: anAdaptor.
		self scheduleForAdaptor: anAdaptor]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>processing</category>

<body package="PVAdaptor-Schema" selector="processAll:">processAll: inputs 
	" If the schema is not a multifile join, there should ordinarily be only one file to process at a time.
	If multiple files are found, it is probably a mistake (i.e. script did not bother to set a timestamp.
	In this case sort files by local name as a meek protection (increases likelihood files will be processed
	in desired order. Quite frankly, the only reason we bother is because there are some sloppy test cases
	that don't set descriptor's timestamp "
	
	| realInputs |
	realInputs := 
		(inputs size &gt; 1 and: [schema multiFileJoin not]) 
			ifTrue: 
				[self system 
					logWarning: #MULTIPLE_FILES_PER_PERIOD_DETECTED
					messageId: #DC10428
					text: 
						'Multiple files per period ' , 
							inputs anyOne timestamp smeeToNumber pvOpportunisticPrintString , 
								' are found -- this should not happen. Please check the design script and data feed mechanism'.
				(inputs asSortedCollection: InputDescriptor sortBlock) asOrderedCollection]
			ifFalse: [inputs].

	realInputs do: [:each | each markScheduled].
	schema process: realInputs.</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>private</category>

<body package="PVAdaptor-Schema" selector="toSeconds:">toSeconds: aSmeeDate

	^aSmeeDate isValid
		ifTrue: [aSmeeDate asPvTimestamp asSeconds]
		ifFalse: [0]</body>

<body package="PVAdaptor-Schema" selector="hasAnyNewInputsToAcquire">hasAnyNewInputsToAcquire
	
	^self newInputsToAcquire notEmpty</body>

<body package="PVAdaptor-Schema" selector="latestPeriodIn:">latestPeriodIn: allInputs 
	
	| start |
	start := 
		allInputs 
			inject: nil
			into: 
				[:current :each | 
				| value |
				value := self startOfPeriod: each.
				current 
					ifNil: [value]
					ifNotNil: [current max: value]].
	^start</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>scheduling</category>

<body package="PVAdaptor-Schema" selector="scheduleForAdaptor:">scheduleForAdaptor: anAdaptor 
	
	self environment do: 
		[self inputsToProcessByPeriodDo: 
			[:eachSet | 
			(self shouldBeProcessed: eachSet) 
				ifTrue: [self processAll: eachSet]
				ifFalse: [^false]]].
	^true</body>

<body package="PVAdaptor-Schema" selector="inputsToProcessByPeriodDo:">inputsToProcessByPeriodDo: aBlock 
	
	| inputs |
	inputs := self inputsToProcess readStream.
	[inputs atEnd] 
		whileFalse: 
			[| nextPeriodInputs |
			nextPeriodInputs := self nextPeriodInputsFrom: inputs.
			nextPeriodInputs isEmpty 
				ifFalse: [aBlock value: nextPeriodInputs]]</body>

<body package="PVAdaptor-Schema" selector="nextPeriodInputsFrom:">nextPeriodInputsFrom: inputStream 
	
	| begin result |
	begin := nil.
	result := OrderedCollection new.
	inputStream do: 
		[:each | 
		| periodStart |
		periodStart := self startOfPeriod: each.
		begin ifNil: [begin := periodStart].
		periodStart = begin 
			ifTrue: [result add: each]
			ifFalse: 
				[inputStream skip: -1.
				^result]].
	^result</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputDescriptorScheduler</class-id> <selector>processInputs</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="elapsedSeconds">elapsedSeconds
	^((self stopTimestamp asUTCMilliseconds - (self startTimestamp ifNil: [self stopTimestamp])) / 1000) asFloat</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>testing</category>

<body package="PVAdaptor-Schema" selector="shouldAcquireOnlyOnce">shouldAcquireOnlyOnce

	^false</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchema class</class-id> <category>sorting</category>

<body package="PVAdaptor-Schema" selector="sortBlock">sortBlock

	^[:a :b | a precedence &gt;= b precedence]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="scheduledTimestamp:">scheduledTimestamp: aDate 
	
	scheduledTimestamp := aDate</body>

<body package="PVAdaptor-Schema" selector="elapsedSeconds">elapsedSeconds
	^((self stopTimestamp asUTCMilliseconds - (self startTimestamp ifNil: [self stopTimestamp]) asUTCMilliseconds) / 1000) asFloat</body>
</methods>


<methods>
<class-id>PROVISO.UBA.SQLInputSchema</class-id> <category>testing</category>

<body package="PVAdaptor-Schema" selector="shouldAcquireOnlyOnce">shouldAcquireOnlyOnce

	^true</body>
</methods>



<methods>
<class-id>PROVISO.UBA.UBAServiceInstance</class-id> <category>adapting</category>

<body package="PVAdaptor-Application" selector="processInputs">processInputs
	
	| toAcquireAndSchedule times |
	toAcquireAndSchedule := self inputSchemas asSortedCollection: InputSchema sortBlock.
	times := 0.
	[toAcquireAndSchedule isEmpty] 
		whileFalse: 
			[times := times + 1.
			times &gt;= 5 
				ifTrue: [^self].
			toAcquireAndSchedule := 
				toAcquireAndSchedule select: 
					[:each | 
					each scheduler processInputsForAdaptor: self.
					each shouldAcquireOnlyOnce 
								ifTrue: [false]
								ifFalse: [each scheduler hasAnyNewInputsToAcquire]]].</body>
</methods>



<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>private</category>

<body package="NGUBA-Application" selector="moveFileToDoFor:using:">moveFileToDoFor: anInputDescriptor using: log 
	
	| sourceURI destURI |
	sourceURI := anInputDescriptor uriInDoneDirectory.
	destURI := anInputDescriptor uriInDoDirectory.
	log fileInterface 
		moveFilename: sourceURI
		toFilename: destURI
		using: log</body>

<body package="NGUBA-Application" selector="moveFileToDoFor:">moveFileToDoFor: anInputDescriptor
	"move processed file from done to do dir"
	
	self transactionDo: [:log | self moveFileToDoFor: anInputDescriptor using: log]</body>

<body package="NGUBA-Application" selector="process:ifValidDo:">process: anInputDescriptor ifValidDo: aBlock 
	
	| currentDesc |
	currentDesc := self descriptorNamed: anInputDescriptor name.
	currentDesc ifNil: [currentDesc := anInputDescriptor].
	currentDesc alreadyProcessed 
		ifTrue: [^self].
	currentDesc ignore 
		ifTrue: 
			[currentDesc doNotProcess.
			^self].
	currentDesc == anInputDescriptor 
		ifFalse: [currentDesc mergeWith: anInputDescriptor].
	(self schema isValidInputDescriptor: currentDesc) 
		ifFalse: 
			[currentDesc uriInDoneDirectory exists 
				ifTrue: [self moveFileToDoFor: currentDesc].
			(self schema isValidInputDescriptor: currentDesc) 
				ifFalse: 
					[self schema logInputDescriptorMissingFor: currentDesc.
					currentDesc doNotProcess.
					^self]].
	(self hasValidTimestampForDescriptor: currentDesc) 
		ifFalse: [self logNoTimestampForDescriptor: currentDesc].
	self descriptor: currentDesc.
	currentDesc adaptor: self.
	[currentDesc startTimestamp ifNil: 
		[currentDesc startTimestamp: anInputDescriptor startTimestamp].
	aBlock value: currentDesc] 
		ensure: 
			[currentDesc stopTimestamp ifNil: [currentDesc stopTimestamp: SmeeDate nowUTC].
			self descriptor: nil.
			currentDesc adaptor: nil]</body>
</methods>



</st-source>
